# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from atop.powerup import IPowerStation
from atop.test import unittest

from quotient import provisioner
from quotient.mimemessage import IMIMEDelivery

class ProvisionerMixin:

    avatarProvisions = provisioner.oneYearService

    def AvatarFactory(self, store, *a, **kw):
        a = unittest._TestCase.AvatarFactory(store, *a, **kw)
        IPowerStation(a).installPowerup(provisioner.Provisioner)
        self.avatarProvisions.grantTo(provisioner.IProvisioner(a))
        return a

def msgFromString(avatar, string):
    return IMIMEDelivery(avatar).createMIMEReceiver(False).feedStringNow(string)
