# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from twisted.trial import unittest

class AtLeastImport(unittest.TestCase):
    def testQuotient(self):
        from quotient import copyright
        from quotient import grabbers
        from quotient import iquotient
        from quotient import mimemessage
        from quotient import provisioner
        from quotient import stats
        from quotient import taglib
        from quotient import tap2
        from quotient import blogup
        from quotient import emailup
        from quotient import prefup
        from quotient import searchup
        from quotient import timezones
        from quotient import voiceup
        from quotient import gcup
        from quotient import reset
        from quotient import cleanup
        from quotient import stats
        from quotient import smartenup

    def testSmarts(self):
        from quotient.smarts import attachment
        from quotient.smarts import image
        from quotient.smarts import person
        from quotient.smarts import note
        from quotient.smarts import question
        from quotient.smarts import phone
        from quotient.smarts import url
        from quotient.smarts import list
        from quotient.smarts import base

    def testBenchmarks(self):
        # XXX benchbot needs to not have top-level code doing stuff
        from quotient.benchmarks import coverage

    def testProto(self):
        from quotient.proto import popup
        from quotient.proto import imapup
        from quotient.proto import sip
        from quotient.proto import smtpin
        from quotient.proto import smtpout

    def testWeb(self):
        from quotient.web import root
        from quotient.web import compose
        from quotient.web import dashboard
        from quotient.web import pools
        from quotient.web import powerup
        from quotient.web import scrubber
        from quotient.web import utility
        from quotient.web import webinterfaces
        from quotient.web import webmail
        from quotient.web import webup
