
from nevow import tags
from nevow import formless
from nevow import freeform

from quotient import taglib
from quotient.web import root


class ProvisionerDisplay(root.Base):
    def render_permissions(self, context, data):
        return ", ".join([k for (k, v) in self.original.permissioner.permissions.items() if v])

    def render_tanks(self, context, data):
        return ", ".join(map(str, self.original.fueltanker.fuel))

    document = taglib.page(title="Provisioner Homer")[
        tags.p["Permissions:", render_permissions],
        tags.p["Tanks:", render_tanks],
    ]
