
from twisted.cred import portal
from twisted.cred import checkers
from twisted.application import service

from auth import Realm
from server import ChatMultiplexor
import irc

r = Realm()
c = checkers.InMemoryUsernamePasswordDatabaseDontUse(**{"username": "password"})
p = portal.Portal(r, (c,))

a = service.Application("Discourse Server")

s = ChatMultiplexor()
s.setName("Chat Multiplexor")
s.setServiceParent(a)

i = irc.ChatService(p, '6667')
i.setName('IRC Chat Service')
i.setServiceParent(s)

application = a
