import urllib, random

from twisted import application
from twisted.trial import unittest
from twisted.internet import reactor, defer, error
from twisted.python import log, components
from twisted.protocols import policies

import quotient
from quotient.web import newclient, functional


def dfrDbg(self):
    if hasattr(self, 'debug'):
        import traceback
        traceback.print_stack()


class Flooder(functional.FunctionalBase, object):
    numCnx = 0
    baseurl = 'http://localhost'
    prts = {'web': '8485'}
    numActions = 0
    opener = newclient.opener()
    baseurl = "http://localhost"
    def __init__(self):
        self.errorSkipDoGets = False

    def dealWithError(self, err):
        r = err.trap(NotImplementedError, error.ConnectionLost)
#        if r == error.ConnectionLost:
#            err.printDetailedTraceback()
#        log.debug('dealWithError')
        if hasattr(err.value, 'status') and err.value.status == '404':
            log.debug("-" * 60)
            log.debug("404 ERROR IN functional.dealWithError \n\n")
            log.debug("request information that caused 404 follows:\n\n")
            for k,v in err.value._request.__dict__.iteritems():
                log.debug("%s: %s" % (k, v))
            log.debug("-" * 60)
            log.debug("\n\n")
        else:
            log.debug('trapped exception')
            log.debug(err.value)
            log.debug("-" * 60)
            if hasattr(err.value, '_request'):
                for k,v in err.value._request.__dict__.iteritems():
                    log.debug("%s: %s" % (k, v))
            log.debug("-" * 60)
        return err

    def doGet(self, path, args={}, timeout=1):
        if self.errorSkipDoGets:
            return
        url = ("%s:%s" % (self.baseurl,self.prts['web'])) + path

        def recordresult(result):
            log.debug("result received!")
            self.result = result
            return 
        if args:
            argumentString = '?'
            for argKey, argValues in args.items():
                if isinstance(argValues, str):
                    argValues = [argValues]
                for val in argValues:
                    argumentString += '%s=%s&' % (urllib.quote(argKey), urllib.quote(val, safe=''))
                    log.debug('doGet argumentString: %s' % argumentString)
            argumentString = argumentString[:-1]
        else:
            argumentString = ''
        log.debug("doGet newclient.Request(%s%s)" % (url, argumentString))
        d = self.opener.open(
            newclient.Request(url + argumentString)
        ).addCallback(newclient.read
        ).addCallback(recordresult
        ).addErrback(self.dealWithError)
        return d

class Tee:
    def __init__(self, *files):
        self.files = files

    def write(self, w):
        for f in self.files:
            f.write(w)

    def flush(self):
        for f in self.files:
            f.flush()


