# -*- test-case-name: test_blogObject -*-
from twisted.trial import unittest

from quotient.test.helper import SetUpMixin
from quotient.test import emaildata
from quotient import mimemessage

from nevow.renderer import DynamicRenderer
from nevow.test import test_flatstan
from nevow.iwoven import ISerializable
from nevow.tags import *

import blogObject
import stan
import time

class DummyRequest:
    v = ''
    def write(self, x):
        self.v+=x
    finished=False
    def finish(self):
        self.finished=True


class FakeBlogObj(object):
    __implements__ = ISerializable
    def __init__(self):
        self.subject = "This is my subject"
        self.gmtime = time.gmtime()
        self.author = "An Author"
        self.body = ''.join([chr(n) for n in xrange(37,123)])

    def getPost(self):
        return [self]

    def serialize(self,context,stream):
        print 'serialize'
        print context, stream   


class BlogObjectTest(test_flatstan.Base):
    def setUp(self):
        pass

    def test_BlogObjectRender(self):
        print 'test_BlogObjectRender'
        print self.render(FakeBlogObj())



