# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.


from twisted.python import reflect
from twisted.python import components



class FakeSession(components.Componentized):
    pass


fs = FakeSession()


class FakeRequest(components.Componentized):
    args = {}
    prepath = ['']
    uri = ''
    path = ''

    def __init__(self, headers=None, args=None):
        self.headers = headers or {}
        self.args = args or {}
        components.Componentized.__init__(self)
        self.sess = FakeSession()

    def getSession(self):
        return self.sess

    v = ''
    def write(self, x):
        self.v += x

    finished=False
    def finish(self):
        self.finished = True

    def setHeader(self, key, val):
        self.headers[key] = val
