# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.
from quotient.proto.twisted_sip import IContact, ILocator
from atop.powerup import Powerup
from atop import fwd

class Voiceup(Powerup):
    __implements__ = IContact, ILocator, Powerup.__implements__
    #online = False
    altcontact = None
    powerupName = "Voice and Telephony"
    
    def setUpPools(self, avatar):
        avatar.setComponent(IContact, self)
        self.greyedOut = True
        self.invisible = True

