// agh someone stab me with a spoon, more client side javascript!

var targets = []

var typedTargets = {}
var validTargets = []

var grabbedNode = null
var overNode = null

var nodeTypes = {}

nodeTypes.targetIcon = function(current) {
    var img = current.childNodes[0]
    while (img.tagName != 'IMG' && img.nextSibling) {
        img = img.nextSibling
    }
    targets.push(img)
}

nodeTypes.typedTarget = function(current) {
    if (!typedTargets[current.value]) {
        typedTargets[current.value] = []
    }
    var targetList = typedTargets[current.value]

    targetList.push(current)
}

function locateTargets() {
    var draggedNode = document.getElementById('quotient_dragged')
    if (!draggedNode) {
        return
    }
    draggedNode.value = ''
    var inputs = document.getElementsByTagName('input')
    for (var i=0; i<inputs.length; i++) {
        var current = inputs[i]
        if (current.className) {
            setupFunc = nodeTypes[current.className]
            if (setupFunc) {
                setupFunc(current)
            }
        }
    }
    var wovenShelfInput = document.getElementById('woven_shelf_input')
    wovenShelfInput.onchange = function(evt) {
        var wovenShelf = document.getElementById('woven_shelf')
        wovenShelf.submit()
    }
}

function findBounds(current) {
    var accumX = 0
    var n = current
    while (n.parentNode != null) {
        if (n.offsetLeft)
            accumX += n.offsetLeft
        if (n.offsetParent)
            n = n.offsetParent
        else
            n = n.parentNode
    }
    
    var accumY = 0
    n = current
    while(n.parentNode != null) {
        if (n.offsetTop)
            accumY += n.offsetTop
        if (n.offsetParent)
            n = n.offsetParent
        else
            n = n.parentNode
    }
    //alert("accum" + accumY + " " + accumX + " " + current.offsetWidth + " " + current.offsetHeight)
    if (!current.offsetWidth) {
        while (!current.offsetWidth) {
            current = current.parentNode
        }
    }
    return {
        t: accumY,
        l: accumX,
        b: accumY + current.offsetWidth,
        r: accumX + current.offsetHeight
    }
}

function grabObject(node) {
    var fd = document.getElementById('woven_drag_feedback')
    fd.style.border = '1px dashed black'
    fd.style.height = '12px'
    fd.style.width = '12px'

    grabbedNode = node
    // Change all targets of the appropriate type to indicate they can be dropped on

    //alert(node.childNodes[0].value)
    document.onmousemove = function (evt) {
        var x = 0
        var y = 0
        if (evt == null) {
            x = event.clientX
            y = event.clientY
        } else {
            x = evt.pageX
            y = evt.pageY
        }
        fd.style.left = (x - 5) + 'px'
        fd.style.top = (y - 5) + 'px'
    }
    var draggedInterfaces = node.childNodes[0].value.split(',')
    for (var x = 0; x < draggedInterfaces.length; x++) {
        var interfaceNodes = typedTargets[draggedInterfaces[x]]
        if (interfaceNodes) {
            for (var y = 0; y < interfaceNodes.length; y++) {
                interfaceNodes[y].src = '/images/icons/target.gif'
            }
        }
    }
    document.onmouseup = function(evt) {
        var fd = document.getElementById('woven_drag_feedback')
        fd.style.border = "none"
        var x = 0
        var y = 0
        if (evt == null) {
            x = event.clientX
            y = event.clientY
        } else {
            x = evt.pageX
            y = evt.pageY
        }

        //alert("x y " + x + " " + y)

        var match = 0
        for (var i = 0; i < draggedInterfaces.length; i++) {
            var interfaceNodes = typedTargets[draggedInterfaces[i]]
            if (interfaceNodes) {
                for (var j = 0; j < interfaceNodes.length; j++) {
                    var current = interfaceNodes[j]

                    var bounds = findBounds(current)
                    var t = bounds.t
                    var l = bounds.l
                    var b = bounds.b
                    var r = bounds.r

                    //alert(current)
                    //alert(bounds)
                    //alert("tlbr" + t + " " + l + " " + b + " " + r)
                    if (x<l||x>r||y<t||y>b) {
                        continue
                    }
                    // Hey kids! Don't hardcode assumptions about the structure of your HTML!
                    // now back to regularly scheduled evil
                    current.value = node.childNodes[0].name
                    current.nextSibling.value = node.childNodes[0].className
                    current.nextSibling.nextSibling.value = node.childNodes[0].name
                    var onch = current.nextSibling.nextSibling.onchange
                    if (onch)
                        onch()
                    match = 1
                    break
                }
            }
            if (match)
                break
        }
        for (var z = 0; z < draggedInterfaces.length; z++) {
            var interfaceNodes = typedTargets[draggedInterfaces[z]]
            if (interfaceNodes) {
                for (var a = 0; a < interfaceNodes.length; a++) {
                    interfaceNodes[a].src = '/images/icons/generic.png'
                }
            }
        }
        document.onmousemove = null
        document.onmouseup = null
        document.onselectstart = null
    }


    document.onselectstart = function (evt) {
        if (evt)
            evt.stopPropagation();
        else
            event.cancelBubble = true;
        return false;
    }

}

function itemToggled(item) {
    var draggedNode = document.getElementById('quotient_dragged')
    var draggedInput = []
    if (draggedNode.value != '') {
        draggedInput = draggedNode.value.split(';')
    }
    var deleting = 0
    for (var i=0; i < draggedInput.length; i++) {
        if (draggedInput[i] == item.value) {
            draggedInput.splice(i, 1)
            deleting = 1
        }
    }
    if (!deleting) {
        draggedInput.splice(draggedInput.length, 0, item.value)
    }
    if (draggedInput.length == 1) {
        for (var j=0; j<targets.length; j++) {
            targets[j].src = '/images/icons/target.gif'
        }
    } else if (draggedInput.length == 0) {
        for (var k=0; k<targets.length; k++) {
            targets[k].src = '/images/icons/generic.png'
        }
    }
    draggedNode.value = draggedInput.join(';')
}

function submitForm(item, poolName) {
    document.getElementById('quotient_pool_name').value = poolName
    var form = item
    while (1) {
        if (form.tagName == 'FORM')
            break
        form = form.parentNode
    }
    form.submit()
}

