from twisted.application.internet import TimerService
from twisted.python import log
import gc

class GCMonitorService(TimerService):
    def __init__(self, callable=None, *a, **kw):
        if callable is None:
            self.callable = self.logobjects
        self.args = a
        self.kwargs = kw

    def logobjects(self):
        log.msg(gc.get_objects())
