from nevow.tags import *
import time


#author subject gmtime(atuple) body

class BlogObject(object):
    def __init__(self, author="somebloke@example.net", 
                       subject="a blog subject",
                       gmtime="Tuesday, March 10, 2004", 
                       body="This is a blog message"):

        self.subject = subject
        self.body = body
        self.gmtime = gmtime
        self.author = author


def renderBlog(context, data):
    rv = div()
    for post in data:
        #this is where stuff happens
        rv[
            div[
                p[post.subject],
                p[post.gmtime],
                p[post.author],
                p[post.body]
            ]
        ]
    return rv

bloglist = [BlogObject() for n in xrange(10)]

doc = html(data=bloglist)[
    head[
        title[
            "bloggers"
        ]
    ],
    body[
        renderBlog
    ]
]

