#!/usr/bin/env python2.3

from twisted.application import service, internet
from twisted.web import server, static, util, twcgi
import base
from storage import CSVStorage, RDBStorage

resource = base.Base()

mySite = server.Site(resource)

# create a new application with name 'HomePage'
application = service.Application('HomePage')

# create the actual tcp server that will listen on a socket
# and respond to requests
i = internet.TCPServer(7777, mySite)

# this attaches the application service to our tcp server's parent
i.setServiceParent(service.IServiceCollection(application))



